"""
Generates ascii grids of nominated areas -
Input: sww file from run_perth.py
       boundaries for grids from project.py
Outputs: ascii grids of specified variables
Stored in the 'outputs_dir' folder for respective .sww file

Note:
If producing a grid for the enitre extent cellsize should be greater than 30m
If producing grids for inundation area resolution should be greater than mesh (ie ~22m)
"""

import project, os
import sys
from anuga.shallow_water.data_manager import convert_dem_from_ascii2netcdf, dem2pts

from anuga.shallow_water.data_manager import sww2dem
from os import sep

directory = project.output_dir

#time_dir = '20080526_104946_run_final_0.6_test_kvanputt'
#time_dir = '20080530_170833_run_final_0.6_exmouth_kvanputt'
#time_dir1 = '20080815_103442_run_final_0.0_polyline_alpha0.1_kvanputt'
time_dir1 = '20080912_154439_run_final_0.6_27255_alpha0.1_kvanputt'

#cellsize = 20
cellsize = 30
#timestep = 0
#area = ['Geordie', 'Sorrento', 'Fremantle', 'Rockingham']
area = 'All'
which_area = area
var = [1,2] # Absolute momentum and depth
#var = [2] # depth
#var = [0,4] #stage and elevation

time_dirs = [time_dir1]
for time_dir in time_dirs:

    name1 = directory+time_dir+sep+project.scenario_name
    #name2 = directory+time_dir+sep+'sww2'+sep+project.scenario_name+'_time_39900_0' #need to get assistance on how to make this into anything

    names = [name1]
    for name in names:

##        for which_area in area:
##            if which_area == 'All':
##            
##            if which_area == 'Geordie':
##                easting_min = project.xminGeordie
##                easting_max = project.xmaxGeordie
##                northing_min = project.yminGeordie
##                northing_max = project.ymaxGeordie
##
##            if which_area == 'Sorrento':
##                easting_min = project.xminSorrento
##                easting_max = project.xmaxSorrento
##                northing_min = project.yminSorrento
##                northing_max = project.ymaxSorrento
##
##            if which_area == 'Fremantle':
##                easting_min = project.xminFremantle
##                easting_max = project.xmaxFremantle
##                northing_min = project.yminFremantle
##                northing_max = project.ymaxFremantle
##
##            if which_area == 'Rockingham':
##                easting_min = project.xminRockingham
##                easting_max = project.xmaxRockingham
##                northing_min = project.yminRockingham
##                northing_max = project.ymaxRockingham

              
            for which_var in var:
                if which_var == 0:  # Stage
                    outname = name + which_area + '_stage' 
                    quantityname = 'stage'

                if which_var == 1:  # Absolute Momentum
                    outname = name + which_area + '_momentum' 
                    quantityname = '(xmomentum**2 + ymomentum**2)**0.5'  

                if which_var == 2:  # Depth
                    outname = name + which_area + '_depth'
                    quantityname = 'stage-elevation'  

                if which_var == 3:  # Speed
                    outname = name + which_area + '_speed'
                    #quantityname = '(xmomentum**2 + ymomentum**2)**0.5/(stage-elevation+1.e-6/(stage-elevation))'  #Speed
                    quantityname = '(xmomentum**2 + ymomentum**2)**0.5/(stage-elevation+1.e-6)'  #Speed
                    
                if which_var == 4:  # Elevation
                    outname = name + which_area + '_elevation'
                    quantityname = 'elevation'  #Elevation

                else: 
                    print 'start sww2dem',area
                    sww2dem(name, basename_out = outname,
                                quantity = quantityname,
                                #timestep = timestep,
                                cellsize = cellsize,      
                                reduction = max, 
                                verbose = True,
                                format = 'asc')
##
##                else:
##                    print 'start sww2dem',which_area, easting_min
##                    sww2dem(name, basename_out = outname,
##                                quantity = quantityname,
##                                #timestep = timestep,
##                                cellsize = cellsize,      
##                                easting_min = easting_min,
##                                easting_max = easting_max,
##                                northing_min = northing_min,
##                                northing_max = northing_max,        
##                                reduction = max, 
##                                verbose = True,
##                                format = 'asc')
##
